// naumann@stce.rwth-aachen.de

#include <cmath>
#include <iostream>
using namespace std;

template<typename T>
T f(T x) {
  return sin(x);
}

template<typename T>
T df_dx(T x) {
  return cos(x);
}

template<typename T>
T ddf_dx_dx(T x) {
  return -sin(x);
}

template<typename T>
T newton(T x) {
  do {
    cout << x << ": " << fabs(f(x)*ddf_dx_dx(x)/pow(df_dx(x),2)) << endl;
    x=x-f(x)/df_dx(x);
  } while (fabs(f(x))>1e-7);
  return x;
}

int main() {
  using T=double;
  T x=1.6;
  cout << "y=" << f(x) << endl;
  x=newton(x);
  cout << "x=" << x << endl;
  cout << "y=" << f(x) << endl;
  cout << "dfdx=" << df_dx(x) << endl;
  cout << "ddfdxx=" << ddf_dx_dx(x) << endl;
  return 0;
}
