/// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"
#include "objective.h"
#include "error_analysis.h"

#include <iostream>
using namespace std;

template<typename T>
T fit(T p, VT<T> xobs, VT<T> yobs);

int main() {
  using T=double;
  T p=0.5;
  VT<T> xobs=VT<T>::Random(nobs); xobs=xobs.cwiseProduct(xobs); 
  VT<T> yobs=VT<T>::Random(nobs); 
  cout << "e=" << e(p,xobs,yobs) << endl;
  p=fit(p,xobs,yobs);
  cout << "p=" << p << endl;
  cout << "e=" << e(p,xobs,yobs) << endl;
  cout << "dedp=" << de_dp(p,xobs,yobs) << endl;
  cout << "ddedpp=" << dde_dp_dp(p,xobs,yobs) << endl;
  cout << "dpdobs (SD)=" << dp_dobs_sym(p,xobs,yobs).transpose() << endl;
  p=0.5;
  cout << "dpdobs (CFD)=" << dp_dobs_cfd(p,xobs,yobs).transpose() << endl;
  p=0.5;
  cout << "dpdobs (TAD)=" << dp_dobs_tad(p,xobs,yobs).transpose() << endl;
  p=0.5;
  cout << "dpdobs (AAD)=" << dp_dobs_aad(p,xobs,yobs).transpose() << endl;
  return 0;
}
