// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"

// right-hand side of ODE determined at link time
template<typename T>
T g(T p, T x, T y); 

template<typename T>
T f(T p, T x) {
  assert(x>0);
  T delta_x=x/m;
  x=0; // initial position fixed to zero
  T y=0; // initial state fixed to zero
  int i=0;
  while (i<m) {
    y=y+delta_x*g(p,x,y); 
    x=x+delta_x; 
    i=i+1;
  } 
  return y;
}
