// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"

template<typename T> 
T g(T p, T x, T y); 

template<typename T> 
T r(T p, T x, T y, T y_prev, T delta_x) { 
  return y-y_prev-delta_x*g(p,x,y);
}

template<typename T>
T bisection(T p, T x, T y, T delta_x) {
  T y_prev=y, y_u=y+2; 
  y=y-2;
  while (fabs(y-y_u)>eps) {
    T y_m=(y_u+y)/2;
    T r_=r(p,x,y,y_prev,delta_x), r_m=r(p,x,y_m,y_prev,delta_x);
    if (fabs(r_m)<eps) {
      y=y_u=y_m;
    }
    else if ((r_<=0&&r_m<=0)||(r_>=0&&r_m>=0)) {
      y=y_m;
    } 
    else {
      y_u=y_m;
    } 
  }
  return y;
}

template<typename T>
T f(T p, T x) {
  assert(x>0);
  T mT=m;
  T delta_x=x/mT;
  x=0;
  T y=0;
  int i=0;
  while (i<m) {
    y=bisection(p,x,y,delta_x); 
    x=x+delta_x; 
    i=i+1;
  } 
  return y;
}
